api/urls.py
from django.urls import include, path
from tastypie.api import Api

from api.models import CategoryResource, CourseResource

api = Api(api_name='v1')
category_resource = CategoryResource()
course_resource = CourseResource()
api.register(category_resource)
api.register(course_resource)

urlpatterns = [
    path('', include(api.urls)),
]

base/urls.py
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('shop.urls')),
    path('api/', include('api.urls')),
]

shop/urls.py
from django.urls import path
from . import views

app_name = 'shop'

urlpatterns = [
    path('', views.index, name='index'),
    path('<int:course_id>', views.single_course, name='single_course'),
]

api/models.py
from tastypie.authorization import Authorization
from tastypie.resources import ModelResource

from api.authentication import CustomApiKeyAuthentication
from shop.models import Category, Course


class CategoryResource(ModelResource):
    class Meta:
        queryset = Category.objects.all()
        resource_name = 'categories'
        allowed_methods = ['get']


class CourseResource(ModelResource):
    class Meta:
        queryset = Course.objects.all()
        resource_name = 'courses'
        allowed_methods = ['get', 'post', 'delete']
        authentication = CustomApiKeyAuthentication()
        authorization = Authorization()

    def hydrate(self, bundle):
        bundle.obj.category_id = bundle.data['category_id']
        return bundle

    def dehydrate(self, bundle):
        bundle.data['category_id'] = bundle.obj.category_id
        bundle.data['category'] = bundle.obj.category
        return bundle

shop/models.py
from django.db import models
from django.utils import timezone


class Category(models.Model):
    title = models.CharField(max_length=300)
    created_at = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return self.title


class Course(models.Model):
    title = models.CharField(max_length=255)
    price = models.FloatField()
    students_qty = models.IntegerField()
    reviews_qty = models.IntegerField()
    created_at = models.DateTimeField(default=timezone.now)
    category = models.ForeignKey(Category, on_delete=models.CASCADE)

    def __str__(self):
        return self.title

api/views.py
from django.shortcuts import render

# Create your views here.

shop/views.py
# from django.http import Http404
from django.shortcuts import get_object_or_404, render

from shop.models import Course


def index(request):
    courses = Course.objects.all()
    return render(request, 'shop/courses.html', {'courses': courses})


def single_course(request, course_id):
    # Option 1
    # try:
    #     course = Course.objects.get(pk=course_id)
    #     return render(request, 'shop/single_course.html', {'course': course})
    # except Course.DoesNotExist:
    #     raise Http404("Course does not exist")

    # Option 2
    course = get_object_or_404(Course, pk=course_id)
    return render(request, 'shop/single_course.html', {'course': course})

templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css">
    <title>{% block title %}{% endblock %}</title>
</head>
<body>
<nav class="navbar navbar-dark bg-dark">
    <div class="container">
        <a href={% url 'shop:index' %} class="navbar-brand">Courses Shop</a>
        <span class="navbar-text">
            <a href="/admin/" target="_blank" class="me-2">Admin</a>
            <a href="/api/v1/" target="_blank">API</a>
        </span>
    </div>
</nav>
<main class="container">
    {% block content %}
    {% endblock %}
</main>
</body>
</html>

templates/shop/courses.html
{% extends 'base.html' %}

{% block title %}All courses{% endblock %}

{% block content %}
<table class="table mt-5 table-bordered table-striped table-hover">
    <thead class="table-dark">
    <tr>
        <th>Title</th>
        <th>Price</th>
        <th>Category</th>
        <th>Students Qty</th>
        <th>Reviews Qty</th>
        <th></th>
    </tr>
    </thead>
    <tbody>
    {% for course in courses %}
    <tr>
        <td><a href={% url 'shop:single_course' course.id %}>{{ course.title }}</a></td>
        <td>{{ course.price }}</td>
        <td>{{ course.category }}</td>
        <td>{{ course.students_qty }}</td>
        <td>{{ course.reviews_qty }}</td>
        <td><button class="btn btn-primary">Buy</button></td>
    </tr>
    {% endfor %}
    </tbody>
</table>
{% endblock %}

templates/shop/single_course.html
{% extends 'base.html' %}

{% block title %}{{ course.title }}{% endblock %}

{% block content %}
    <h1 class="mt-4">{{ course.title }}</h1>
    <br>
    <h2>Category: {{ course.category }}</h2>
    <h4>Price: {{ course.price }}</h4>
    <h4>Students Qty: {{ course.students_qty }}</h4>
    <h4>Reviews Qty: {{ course.reviews_qty }}</h4>
    <button class="btn btn-primary">Buy</button>
{% endblock %}